'use strict';

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = serverRenderRelayComponents;

var _server = require('react-dom/server');

var _server2 = _interopRequireDefault(_server);

var _buildConsoleReplay = require('./buildConsoleReplay');

var _buildConsoleReplay2 = _interopRequireDefault(_buildConsoleReplay);

var _reactRelay = require('react-relay');

var _reactRelay2 = _interopRequireDefault(_reactRelay);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function serverRenderRelayComponents(options) {
  var componentName = options.componentName;
  var domNodeId = options.domNodeId;
  var routeName = options.routeName;

  var htmlResult = '';
  var hasErrors = false;
  var componentObj = ReactOnRails.getComponent(componentName);
  var routeObj = ReactOnRails.getRoute(routeName);

  // CONSIDER NOT RELEASING THE OPTION version
  var component = componentObj.component;
  var route = routeObj.route;

  htmlResult = _server2.default.render(_react2.default.createElement(_reactRelay2.default.RootContainer, {
    Component: component,
    route: route,
    renderLoading: function renderLoading() {
      return _react2.default.createElement(
        'div',
        { className: 'loader' },
        _react2.default.createElement('span', { className: 'fa fa-spin fa-spinner' })
      );
    }
  }), document.getElementById(domNodeId));

  var consoleReplayScript = (0, _buildConsoleReplay2.default)();

  return (0, _stringify2.default)({
    html: htmlResult,
    consoleReplayScript: consoleReplayScript,
    hasErrors: hasErrors
  });
}